package solvers.dataReduction;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Map;
import java.util.Set;

import solvers.UnsolvableException;

public class RemoveConflictsWithRequiredVertices<V, E> implements RuleInterface<V, E>
{
	// private static <V> boolean containsRequiredVertex(Set<V> conflictSet, Set<V>
	// requiredVertices)
	// {
	// for (final V req : requiredVertices)
	// {
	// if ( conflictSet.contains(req) )
	// return true;
	// }
	// return false;
	// }

	@Override
	public boolean reduce(SimpleRuleProvider<V, E> logger) throws UnsolvableException
	{
		// if ( logger instanceof AdvancedRuleProvider )
		// {
		// final Map<V, Set<V>> map = ((AdvancedRuleProvider<V, E>) logger).getConflictMapping();
		// for (final V v : map.keySet())
		// {
		// final Set<V> conflictSet = map.get(v);
		// if ( conflictSet != null && conflictSet.size() > 0 )
		// {
		// if ( logger.getRequiredVertices().contains(v) )
		// {
		// if ( RemoveConflictsWithRequiredVertices
		// .containsRequiredVertex(conflictSet, logger.getRequiredVertices()) )
		// throw new UnsolvableException();
		// else
		// {
		// for (final V del : new LinkedList<V>(conflictSet))
		// {
		// logger.removeVertex(del);
		// }
		// return true;
		// }
		// }
		// else if ( RemoveConflictsWithRequiredVertices.containsRequiredVertex(conflictSet,
		// logger.getRequiredVertices()) )
		// {
		// logger.removeVertex(v);
		// return true;
		// }
		// }
		// }
		// }
		// return false;
		boolean somethingRemoved = false;
		if ( logger instanceof AdvancedRuleProvider )
		{
			final Map<V, Set<V>> map = ((AdvancedRuleProvider<V, E>) logger).getConflictMapping();

			final ArrayList<V> reqVertices = new ArrayList<V>(logger.getRequiredVertices());
			for (int i = 0; i < reqVertices.size(); i++)
			{
				final Set<V> conflicts = map.get(reqVertices.get(i));
				for (int j = i + 1; j < reqVertices.size(); j++)
				{
					if ( conflicts.contains(reqVertices.get(j)) )
						throw new UnsolvableException();
				}
				for (final V del : new LinkedList<V>(conflicts))
				{
					logger.removeVertex(del);
					somethingRemoved = true;
				}
			}
		}
		return somethingRemoved;
	}
}